
//********************************************************************************************
//function                                                                  //
//argument none                                                                             //
//return   none                                                                             //
//********************************************************************************************
void AdcInit(void)
{
  
  RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;    //    PORTA
  // PORTA.6 -  
  GPIOA->CRL   &= ~GPIO_CRL_MODE3;       //  MODE
  GPIOA->CRL   &= ~GPIO_CRL_CNF3;        //  CNF
  
  RCC->APB2ENR |=  RCC_APB2ENR_ADC1EN;   //   
  RCC->CFGR    |=  RCC_CFGR_ADCPRE;      // 
  ADC1->CR2 |= ADC_CR2_ADON;           
  ADC1->CR2 |= ADC_CR2_TSVREFE;   
  ADC1->CR2 &= ~ADC_CR2_EXTSEL;    
  ADC1->CR2 &= ~ADC_CR2_EXTTRIG;
  ADC1->SMPR2 |= ADC_SMPR2_SMP3; 
  
  ADC1->CR2 |= ADC_CR2_DMA;		//  DMA
  ADC1->SQR1  |= ADC_SQR1_L; // 16 

  ADC1->SMPR2 = (7<<12)|(7<<9)|(7<<6)|(7<<3);        // 0x00000028; set sample time channel1 (55,5 cycles)
  ADC1->SMPR1 = (7<<18)|(7<<21);        // 0x00000028; set sample time channel1 (55,5 cycles)

  ADC1->SMPR1 |= ADC_SMPR1_SMP17; //    17 - 239.5   
  ADC1->SMPR2 |= ADC_SMPR2_SMP3;  //    3 - 239.5   

  ADC1->SQR3 |= ADC_SQR3_SQ1_0 | ADC_SQR3_SQ1_4;    //  17
  ADC1->SQR3 |= ADC_SQR3_SQ2_1 | ADC_SQR3_SQ2_0;    //  3  
  ADC1->SQR3 |= ADC_SQR3_SQ3_1 | ADC_SQR3_SQ3_0;    //  3  
  ADC1->SQR3 |= ADC_SQR3_SQ4_1 | ADC_SQR3_SQ4_0;    //  3  
  ADC1->SQR3 |= ADC_SQR3_SQ5_1 | ADC_SQR3_SQ5_0;    //  3  
  ADC1->SQR3 |= ADC_SQR3_SQ6_1 | ADC_SQR3_SQ6_0;    //  3  
  ADC1->SQR2 |= ADC_SQR2_SQ7_1 | ADC_SQR2_SQ7_0;    //  3  
  ADC1->SQR2 |= ADC_SQR2_SQ8_1 | ADC_SQR2_SQ8_0;    //  3  
  ADC1->SQR2 |= ADC_SQR2_SQ9_1 | ADC_SQR2_SQ9_0;    //  3    
  ADC1->SQR2 |= ADC_SQR2_SQ10_1 | ADC_SQR2_SQ10_0;  //  3    
  ADC1->SQR2 |= ADC_SQR2_SQ11_1 | ADC_SQR2_SQ11_0;  //  3  
  ADC1->SQR2 |= ADC_SQR2_SQ12_1 | ADC_SQR2_SQ12_0;  //  3  
  ADC1->SQR1 |= ADC_SQR1_SQ13_1 | ADC_SQR1_SQ13_0;  //  3  
  ADC1->SQR1 |= ADC_SQR1_SQ14_1 | ADC_SQR1_SQ14_0;  //  3  
  ADC1->SQR1 |= ADC_SQR1_SQ15_1 | ADC_SQR1_SQ15_0;  //  3  
  ADC1->SQR1 |= ADC_SQR1_SQ16_1 | ADC_SQR1_SQ16_0;  //  3  
    
  ADC1->CR1 |= ADC_CR1_SCAN;
  ADC1->CR2 |= ADC_CR2_TSVREFE;   
  ADC1->CR2 |= ADC_CR2_CONT;

  /* Enable ADC1 reset calibration register */   
  ADC_ResetCalibration(ADC1);
  /* Check the end of ADC1 reset calibration register */
  while(ADC_GetResetCalibrationStatus(ADC1));

  /* Start ADC1 calibration */
  ADC_StartCalibration(ADC1);
  /* Check the end of ADC1 calibration */
  while(ADC_GetCalibrationStatus(ADC1));


  ADC1->CR2 |= ADC_CR2_SWSTART;
  
}
