void DMA_init (void)
{
  RCC->AHBENR |= RCC_AHBENR_DMA1EN;           //   DMA
  DMA1_Channel1->CPAR = (uint32_t) &ADC1->DR; //   
  DMA1_Channel1->CMAR = (uint32_t) &adc_meas; //    
  DMA1_Channel1->CCR &= ~DMA_CCR1_DIR;        //    " -> "
  DMA1_Channel1->CNDTR = 64;                   // -    (..   )
  DMA1_Channel1->CCR &= ~DMA_CCR1_PINC;       //    
  DMA1_Channel1->CCR |= DMA_CCR1_MINC;        //     
  DMA1_Channel1->CCR |= DMA_CCR1_PSIZE_0;     //    16 
  DMA1_Channel1->CCR |= DMA_CCR1_MSIZE_0;     //     32 
  DMA1_Channel1->CCR |= DMA_CCR1_PL;          //   
  DMA1_Channel1->CCR |= DMA_CCR1_TCIE;        //        
  DMA1_Channel1->CCR |= DMA_CCR1_CIRC;        //  
  DMA1_Channel1->CCR |= DMA_CCR1_EN;          //  DMA
}



void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

  NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

void DMA1_Channel1_IRQHandler(void) 
{
  int i;
  uint32_t adc_avg=0;
  if (DMA_GetITStatus(DMA1_IT_TC1)) 
  {
    counter_dma++;
    
    vref_hex=0;
    for(i=0;i<64;i++)
    {
      if((i!=0)&(i!=16)&(i!=32)&(i!=48))
      {
        adc_avg+=adc_meas[i];
      } else
      {
        vref_hex+=adc_meas[i];
      }
    }
    vref_hex/=4;

    adc_avg=adc_avg+((pcb_resistance*adc_avg)/100);
    adc_avg/=60;
    adc_result_massive[0]=adc_avg;
    for(i=96*4;i>0;i--)adc_result_massive[i]=adc_result_massive[i-1];
  }
  DMA_ClearITPendingBit(DMA1_IT_GL1);
  
}
