/**********************************************

     Nokia 2760 
: 1 .
: 96 x 68

: Shodan (www..net)

   3310  Aheir  .
     -2

**********************************************/

#include "font5x8.h"

//***********************************************************
//        
//***********************************************************


//  RST
#define LCD_RST_H   GPIOB->BSRR|=GPIO_BSRR_BS3 
#define LCD_RST_L   GPIOB->BSRR|=GPIO_BSRR_BR3

//  DATA
#define LCD_DATA_H  GPIOB->BSRR|=GPIO_BSRR_BS5
#define LCD_DATA_L  GPIOB->BSRR|=GPIO_BSRR_BR5

//  CLK
#define LCD_CLK_H   GPIOB->BSRR|=GPIO_BSRR_BS6
#define LCD_CLK_L   GPIOB->BSRR|=GPIO_BSRR_BR6

//  CS
#define LCD_CS_H    GPIOB->BSRR|=GPIO_BSRR_BS4
#define LCD_CS_L    GPIOB->BSRR|=GPIO_BSRR_BR4


#define PIXEL_OFF	0		//    -    
#define PIXEL_ON	1
#define PIXEL_XOR	2

#define LCD_X_RES               96	//      
#define LCD_Y_RES               72    
#define LCD_CACHSIZE          LCD_X_RES*LCD_Y_RES/8  

#define Cntr_X_RES              96    	//  
#define Cntr_Y_RES              72   
#define Cntr_buf_size           Cntr_X_RES*Cntr_Y_RES/8

#define lcd_CMD 1
#define lcd_DATA 2


char lcd_buf[20];		        //      LCD
unsigned char  LcdCache [LCD_CACHSIZE];	// 
unsigned int   LcdCacheIdx;             //    


//***************************************************
//**************** ******************
//***************************************************
void LcdSend (unsigned char data, unsigned char cmd);    			//Sends data to display controller
void LcdUpdate (void);   							//Copies the LCD cache into the device RAM
void LcdClear (void);    							//Clears the display
void LcdInit ( void );								// SPI  
//void LcdContrast (unsigned char contrast); 					//contrast -> Contrast value from 0x00 to 0x7F
//void LcdMode (unsigned char mode); 						// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
//void LcdPwrMode (void);								//  / 
//void LcdPwrOff (void);								// 
void LcdPwrOn (void);								// 
void LcdPixel (unsigned char x, unsigned char y, unsigned char mode);     	//Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
void LcdLine (int x1, int y1, int x2, int y2, unsigned char mode);  		//Draws a line between two points on the display
//void LcdCircle(char x, char y, char radius, unsigned char mode);		//      
//void LcdBatt(int x1, int y1, int x2, int y2, unsigned char persent);		//      %
void LcdGotoXYFont (unsigned char x, unsigned char y);   			//Sets cursor location to xy location. Range: 1,1 .. 14,6
void clean_lcd_buf (void);							//  
void LcdChr (int ch);								//Displays a character at current cursor location and increment cursor location
void LcdString (unsigned char x, unsigned char y);				//Displays a string at current cursor location
void LcdChrBold (int ch);							//    ,   )
void LcdStringBold (unsigned char x, unsigned char y);				//    
void LcdChrBig (int ch);							//    , 
void LcdStringBig (unsigned char x, unsigned char y);				//  
//***************************************************
// UPDATE ##1
void LcdBar(int x1, int y1, int x2, int y2, unsigned char persent);		//  -     ""
void LcdBarLine(unsigned char line, unsigned char persent);			//  -   
void LcdStringInv (unsigned char x, unsigned char y);                           //      (  )



void init_lcd_port() //   LCD 
{

  RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; 
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN; //   APB2
  AFIO->MAPR |= AFIO_MAPR_SWJ_CFG_JTAGDISABLE; //disable JTAG, enable SWD
  
  //  PB7 - -  ()
  GPIOB->CRL |=   GPIO_CRL_MODE7_1; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &=  ~GPIO_CRL_MODE7_0; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &= ~GPIO_CRL_CNF7; //   CNF 0,0 (  )
  
  //  PB6 - CLK
  GPIOB->CRL |=   GPIO_CRL_MODE6_1; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &=  ~GPIO_CRL_MODE6_0; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &= ~GPIO_CRL_CNF6; //   CNF 0,0 (  )
  
  //  PB5 - SDA
  GPIOB->CRL |=   GPIO_CRL_MODE5_1; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &=  ~GPIO_CRL_MODE5_0; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &= ~GPIO_CRL_CNF5; //   CNF 0,0 (  )
  
  //  PB4 - CS
  GPIOB->CRL |=   GPIO_CRL_MODE4_1; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &=  ~GPIO_CRL_MODE4_0; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &= ~GPIO_CRL_CNF4; //   CNF 0,0 (  )
  
  //  PB3 - RST
  GPIOB->CRL |=   GPIO_CRL_MODE3_1; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &=  ~GPIO_CRL_MODE3_0; //   MODE 1,1 ( 50 MHz)
  GPIOB->CRL &= ~GPIO_CRL_CNF3; //   CNF 0,0 (  )
  
}

void LcdInit()
{
  LCD_CS_L;
  LCD_RST_L;
  delay_ms(10);
  LCD_RST_H;
  delay_ms(10);
  LcdSend(0xE2,lcd_CMD);
  delay_ms(10);
  LcdSend(0xAF,lcd_CMD);
  LcdSend(0xA4,lcd_CMD);
  LcdSend(0x2F,lcd_CMD);
  LcdSend(0xB0,lcd_CMD);
  LcdSend(0x10,lcd_CMD);
  LcdSend(0x00,lcd_CMD);
  LcdSend(0x90,lcd_CMD); //  0x90  - 0x9f 
  //LcdSend(0xA1,lcd_CMD);//    
  
}

void LcdSend (unsigned char data, unsigned char cmd)    //Sends data to display controller
{
uint8_t		sdata,sbit,ibit;
  
  sdata=data;
  LCD_CLK_L;	//clk  
  LCD_CS_L;		//CS  
//  LCD_DATA_L;
  if(cmd==lcd_CMD){LCD_DATA_L;} // 
  else            {LCD_DATA_H;} // 
  
  LCD_CLK_H;	// 		
  LCD_CLK_L;	//
  ibit=0;
  while(ibit<8) //    
  {
    sbit=sdata&0x80;
    if (sbit==0x80)
    {
      LCD_DATA_H; 	
    }
    else
    {
      LCD_DATA_L; 	
    }
    LCD_CLK_H;	// 		
    LCD_CLK_L;	//
    sdata=sdata<<1;
    ibit++;
  }
  LCD_DATA_L;
  
  
  
}


void LcdUpdate (void)   //Copies the LCD cache into the device RAM
{
  int i,j;

  LcdSend(0xB0,lcd_CMD); //    
  LcdSend(0x10,lcd_CMD);
  LcdSend(0x00,lcd_CMD);
  
  for (i = 0; i < (LCD_Y_RES/8); i++)		//  
    for (j = LCD_X_RES-1; j>=0; j--)		//    8 
    {
      LcdSend(LcdCache[((i*LCD_X_RES)+j)], lcd_DATA); //    ,       .
    }
}


void LcdClear (void)    //Clears the display
{
  int i;
  
  for (i = 0; i < LCD_CACHSIZE; i++) LcdCache[i] = 0;	//   0
  LcdUpdate ();
}


void LcdClear_massive (void)    //Clears the display
{
  int i;
  
  for (i = 0; i < LCD_CACHSIZE; i++) LcdCache[i] = 0;	//   0
}


void LcdPixel (unsigned char x, unsigned char y, unsigned char mode)     //Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
{
  int index;
  unsigned char offset, data;
  
  if ( x > LCD_X_RES ) return;	//     - 
  if ( y > LCD_Y_RES ) return;
  
  index = (((int)(y)/8)*96)+x;    //      
  offset  = y-((y/8)*8);          //     
  
  data = LcdCache[index];         //    
  
  if ( mode == PIXEL_OFF ) data &= ( ~( 0x01 << offset ) );	//    
  else if ( mode == PIXEL_ON ) data |= ( 0x01 << offset );
  else if ( mode  == PIXEL_XOR ) data ^= ( 0x01 << offset );
  
  LcdCache[index] = data;		//  
}

void LcdLine (int x1, int y1, int x2, int y2, unsigned char mode)  	//Draws a line between two points on the display -  
{
  signed int dy = 0;
  signed int dx = 0;
  signed int stepx = 0;
  signed int stepy = 0;
  signed int fraction = 0;
  
  if (x1>LCD_X_RES || x2>LCD_X_RES || y1>LCD_Y_RES || y2>LCD_Y_RES) return;
  
  dy = y2 - y1;
  dx = x2 - x1;
  if (dy < 0) 
  {
    dy = -dy;
    stepy = -1;
  }
  else stepy = 1;
  if (dx < 0)
  {
    dx = -dx;
    stepx = -1;
  }
  else stepx = 1;
  dy <<= 1;
  dx <<= 1;
  LcdPixel(x1,y1,mode);
  if (dx > dy)
  {
    fraction = dy - (dx >> 1); 
    while (x1 != x2)
    {
      if (fraction >= 0)
      {
        y1 += stepy;
        fraction -= dx;
      }
      x1 += stepx;
      fraction += dy;  
      LcdPixel(x1,y1,mode);
    }
  }
  else
  {
    fraction = dx - (dy >> 1);
    while (y1 != y2)
    {
      if (fraction >= 0)
      {
        x1 += stepx;
        fraction -= dy;
      }
      y1 += stepy;
      fraction += dx;
      LcdPixel(x1,y1,mode);
    }
  }
}


void LcdGotoXYFont (unsigned char x, unsigned char y)   //Sets cursor location to xy location. Range: 1,1 .. 14,6
{
  //if (x <= 14 && y <= 6) 
  LcdCacheIdx = ( (int)(y) - 1 ) * 96 + ( (int)(x) - 1 ) * 6;
}

void clean_lcd_buf (void)	//  
{
  char i;
  
  for (i=0; i<19; i++) lcd_buf[i] = 0;
} 

void LcdChr (int ch)	//Displays a character at current cursor location and increment cursor location
{
  char i;
  if(ch>0x7f)
  {
    for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = lcd_font_table_rus[(ch*5+(i)-0x3C0)];	// -       - 5 
  }else{
    for ( i = 0; i < 5 ; i++ ) LcdCache[LcdCacheIdx++] = lcd_font_table[(ch*5+(i)-0xA0)];	// -       - 5         
  }
  LcdCache[LcdCacheIdx++] = 0x00;	//   
}

void LcdChrInv (int ch)	//Displays a character at current cursor location and increment cursor location
{
  unsigned char i;
  if(ch>0x7f)
  {     	
    for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = ~(lcd_font_table_rus[(ch*5+i-0x3C0)]);	// -       - 5 
  }else{
    for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = ~(lcd_font_table[(ch*5+i-0xA0)]);	// -       - 5         
  }
  LcdCache[LcdCacheIdx++] = 0xFF;	//   
}

void LcdString (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;
  
  if (x > 17 || y > 8) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 17; i++ ) if (lcd_buf[i]) LcdChr (lcd_buf[i]);
  clean_lcd_buf(); 
}

void LcdStringInv (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;
  
  if (x > 17 || y > 8) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 17-x; i++ ) if (lcd_buf[i]) LcdChrInv (lcd_buf[i]);
  clean_lcd_buf(); 
}

void LcdChrBold (int ch)	//Displays a bold character at current cursor location and increment cursor location
{
  unsigned char i;
  unsigned char a = 0, b = 0, c = 0;
  
  for ( i = 0; i < 5; i++ )
  {
    if(ch>0x7f)
    {
      c = lcd_font_table_rus[(ch*5+i-0x3C0)];		//   
    }else{
      c = lcd_font_table[(ch*5+i-0xA0)];		//                   
    }
    
    b =  (c & 0x01) * 3;            //""     
    b |= (c & 0x02) * 6;
    b |= (c & 0x04) * 12;
    b |= (c & 0x08) * 24;
    
    c >>= 4;
    a =  (c & 0x01) * 3;
    a |= (c & 0x02) * 6;
    a |= (c & 0x04) * 12;
    a |= (c & 0x08) * 24;
    
    LcdCache[LcdCacheIdx] = b;	//    
    LcdCache[LcdCacheIdx+1] = b;    //    
    LcdCache[LcdCacheIdx+96] = a;
    LcdCache[LcdCacheIdx+97] = a;
    LcdCacheIdx = LcdCacheIdx+2;
  }
  LcdCache[LcdCacheIdx++] = 0x00;	//   
  LcdCache[LcdCacheIdx++] = 0x00;
}

void LcdStringBold (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;
  
  if (x > 17 || y > 8) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 17-x; i++ ) if (lcd_buf[i]) LcdChrBold (lcd_buf[i]); 
  clean_lcd_buf();
}

void LcdChrBig (int ch)	//Displays a character at current cursor location and increment cursor location
{
  unsigned char i;
  unsigned char a = 0, b = 0, c = 0;
  
  for ( i = 0; i < 5; i++ )
  {
    if(ch>0x7f)
    {
      c = lcd_font_table_rus[(ch*5+i-0x3C0)];		//        	            
    }else{
      c = lcd_font_table[(ch*5+i-0xA0)];		//   
    }
    
    b =  (c & 0x01) * 3;            //""     
    b |= (c & 0x02) * 6;
    b |= (c & 0x04) * 12;
    b |= (c & 0x08) * 24;
    
    c >>= 4;
    a =  (c & 0x01) * 3;
    a |= (c & 0x02) * 6;
    a |= (c & 0x04) * 12;
    a |= (c & 0x08) * 24;
    LcdCache[LcdCacheIdx] = b;
    LcdCache[LcdCacheIdx+96] = a;
    LcdCacheIdx = LcdCacheIdx+1;
  }
  
  LcdCache[LcdCacheIdx++] = 0x00;
}

void LcdStringBig (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;
  
  if (x > 17 || y > 8) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 17-x; i++ ) if (lcd_buf[i]) LcdChrBig (lcd_buf[i]); 
  clean_lcd_buf();
}
