
#define pcb_resistance 0  //    (        , 100, 300, 500)

#include "stm32f10x.h"
#include "system_stm32f10x.c"
#include <stdio.h>
#include <stdint.h>
#include "stm32f10x_conf.h"
#include "stm32f10x_rcc.c"
#include "stm32f10x_it.h"
#include "stm32f10x_it.c"
#include "stm32f10x_adc.h"
#include "stm32f10x_adc.c"
#include "stm32f10x_dma.h"
#include "stm32f10x_dma.c"

volatile int counter_dma=0;
volatile uint16_t adc_meas[65];
volatile uint32_t vref_hex;
volatile float ripple_avg,low_level_voltage;
volatile uint32_t adc_result_massive[96*4];
volatile float null_offset=0;


#include <misc.h>
#include <misc.c>

#include "delay.h"
#include "ext2760.h"
#include "adc.h"
#include "dma.h"

#define SYSCLK_FREQ_24MHz

int main()
{
  
  uint32_t bad_point,i;
  float v_draw=70;
  volatile   float voltage_one_bit=0;
  float voltage_cur,voltage,ripple_max,ripple_min,ripple;
  uint32_t voltage_massive[97];
  
  RCC_DeInit ();
  RCC_HSEConfig(RCC_HSE_OFF); 
  RCC_HSICmd(ENABLE); 
  
  RCC_HCLKConfig(RCC_SYSCLK_Div1); 
  RCC_PCLK1Config(RCC_HCLK_Div1); 
  RCC_PCLK2Config(RCC_HCLK_Div1); 
  RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_2); 
  RCC_SYSCLKConfig(RCC_SYSCLKSource_HSI); 
  
  RCC_PLLCmd(ENABLE); 
  
  RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; //    A, C,  
  
  NVIC_Configuration();  

  init_lcd_port();
  LcdInit();                 //  
  LcdClear();                // 
  GPIOB->BRR = GPIO_BRR_BR7; //  

      
  sprintf (lcd_buf, " ... "); //     
  LcdString(1,5);
  clean_lcd_buf();  
  LcdUpdate();

  delay_ms(400);
  
  AdcInit(); 
  DMA_init();
  
  counter_dma=0;
  
  while(counter_dma<96);

  voltage_one_bit=1.2;
  voltage_one_bit/=vref_hex;
  voltage=voltage_one_bit*adc_result_massive[1];
  null_offset=voltage+voltage_one_bit; //  

  if(null_offset>0.025)
  {
    sprintf (lcd_buf, " "); //     
    LcdString(1,5);
    clean_lcd_buf();  
    LcdUpdate();   
    while(1);
  }
  
  
  for(i=0;i<(96*4);i++)
  {
    voltage_massive[i]=0;
  }

  low_level_voltage=0;  
  while(1)
  {
    if(bad_point>30)
    {
     ripple_avg=((ripple_max-ripple_min)/2)+ripple_min;
     if((ripple_max-ripple_min)>100)
     bad_point=0;
     low_level_voltage=(ripple_avg/10)*10; //   
     if(low_level_voltage<50)
     {
       low_level_voltage=0;
     } else {
       low_level_voltage-=50;
     }
     if((ripple_max-ripple_min)>100)low_level_voltage=ripple_max-100;
    }
   
    for(i=0;i<(96*4);i++)
    {
      
      voltage_one_bit=1.2;
      voltage_one_bit/=vref_hex;
      voltage=voltage_one_bit*adc_result_massive[i];
      voltage-=null_offset; //  
      voltage*=1853; //  5-2.7 ( 4-10 = 400)
      voltage_massive[i]=(uint32_t)voltage;

      if(i==0)
      {
        voltage_cur=voltage;
        ripple_max=voltage_massive[0];
        ripple_min=voltage_massive[0];
      }

      if(voltage_massive[i]>ripple_max)ripple_max=voltage_massive[i];
      if(voltage_massive[i]<ripple_min)ripple_min=voltage_massive[i];
      if(ripple_max>(low_level_voltage+100))bad_point++;
      if(ripple_min< low_level_voltage)bad_point++;

      v_draw=(voltage-low_level_voltage)/3;
      
      if((v_draw>0)&(i%4==0))LcdPixel(i/4, 64-(uint32_t)v_draw, 1);        
      
    }

      if(ripple_max>(low_level_voltage+100))bad_point++;
      if(ripple_min< low_level_voltage)bad_point++;
    
    
    for(i=0;i<24;i++)LcdPixel(i*4, 64, 1);    
    for(i=0;i<48;i++)LcdPixel(i*2, 48, 1);    
    for(i=0;i<24;i++)LcdPixel(i*4, 32, 1);    
    
    sprintf(lcd_buf,  "%4i",(uint32_t)low_level_voltage+100); 
    LcdString(12,4);                            
    clean_lcd_buf();
    
    sprintf(lcd_buf,  "%4i",(uint32_t)low_level_voltage); 
    LcdString(12,8);
    clean_lcd_buf();
    
    
    ripple=ripple_max-ripple_min;
    
    sprintf(lcd_buf,  "  | |  "); //         
    LcdString(1,1);                            // //        8
    clean_lcd_buf();
    
    sprintf(lcd_buf,  "%4i |%4i |%4i",(uint32_t)voltage_cur,(uint32_t)ripple_max,(uint32_t)ripple_min); //     
    LcdString(1,2);                            // //        8
    clean_lcd_buf();
    
    sprintf (lcd_buf, " %4iV",(uint32_t)ripple); //     
    LcdString(1,3);                            // //        8
    clean_lcd_buf();
    
    for(i=0;i<96;i++)LcdPixel(i, 15, 1);        
    
    LcdUpdate();
    LcdClear_massive();
  }  
}


#ifdef  USE_FULL_ASSERT

/**
* @brief  Reports the name of the source file and the source line number
*         where the assert_param error has occurred.
* @param  file: pointer to the source file name
* @param  line: assert_param error line source number
* @retval None
*/
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
  ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  
  /* Infinite loop */
  while (1)
  {
  }
}

#endif

